package CalculiX;

// This class describes an object that is able to build
// expressions of each kind. We refer to such an object as an
// "expression factory".

// When constructing abstract syntax trees, the parser relies on an
// expression factory instead of creating objects directly via "new".
// This allows the parser to be self-contained (that is, even if the
// various sub-classes of Expression have not been defined yet, the
// parser can be compiled). This is exploited by TD Interpretation.

class ExpressionFactory {

  Value buildValue (int i){return null;}

  Value buildValue (boolean b){return null;}

  Expression buildConstant (int i){return null;}

  Expression buildConstant (boolean b){return null;}

  Expression buildIntegerOperation (Expression left, Operator op, Expression right){return null;}

  Expression buildBooleanOperation (Expression left, Connective op, Expression right){return null;}

  Expression buildBooleanNegation (Expression e){return null;}

  Expression buildIntegerComparison (Expression left, Comparator op, Expression right){return null;}

  Expression buildIf (Expression condition, Expression then_branch, Expression else_branch){return null;}

  Expression buildLet (String x, Expression left, Expression right){return null;}

  Expression buildVarRead (String x){return null;}

  Expression buildSigma (String x, Expression lo, Expression hi, Expression body){return null;}

}
